/***************************************************************************
                          Screen.cxx - Screen abstraction, alows me to do
                          Vio (OS/2) subclasses, curses (POSIX) subclasses,
                          Win32 Console API (Windows) subclasses, etc.
                             -------------------
    begin                : Thu Mar  1 13:15:18 IST 2001
    copyright            : (C) 2001 by Arie Tal
    email                : tal_arie@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string.h> //PORT: added
#include "Screen.h"

#define SHORT_HELP_MESSAGE "     Tip: use ESC-1 for online help, ESC-0 for the popup menu "

void
Screen::MessageClear(int force)
{
  if (!force && !message_dirty) return ;
  message_dirty = 0 ;
  
  static char buf[MAX_SCREEN_WIDTH] ;
  buf[0]='\0' ;
 int width = getWidth() ;
  for (int i=strlen(buf) ; i < width-2 ; i++)
    buf[i] = ' ' ;
  buf[width-2] = '\0' ;
  _show_message(buf) ;
  message_dirty = 0 ;
}

void
Screen::MessageTip(int force)
{
  if (!force && !message_dirty) return ;
  message_dirty = 0 ;
  
  static char buf[MAX_SCREEN_WIDTH]=SHORT_HELP_MESSAGE ;
//  buf[0]='\0' ;
  int width = getWidth() ;
  for (int i=strlen(buf) ; i < width-2 ; i++)
    buf[i] = ' ' ;
  buf[width-2] = '\0' ;
  Message(buf) ;
  message_dirty = 0 ;
}
